#pragma once
#include <atlsync.h>
#include "AppDefine.h"
#include "updateutil.h"

enum UPDATE_ERROR_CODE
{
	ERROR_NONE = 0,
	ERROR_UNKNOWN_ERROR,
	ERROR_UNINSTALLING,
	ERROR_WRONG_QUERY,
	ERROR_UPDATING,
	ERROR_SETUPDOWNLOAD
};

enum UPDATE_STATUS
{
	UPDATE_NO = 0,
	UPDATE_STARTED,
	UPDATE_DONE,
	UPDATE_ERROR,
};

class CAgentWrapper
{
public:
	CAgentWrapper(void);
	~CAgentWrapper(void);
	_VERSION GetVersionLocal();
	_VERSION GetVersionRecent();
	BOOL GetIsChanged();
	BOOL GetIsInstalled();
	BOOL GetUninstallerFilepath(LPTSTR szUninserllerPath, const int cch);
	int GetUninstallerType(LPTSTR szUninsallParameter, const int cch);
	BOOL DoUpgrade( bool bSilent );
	UPDATE_ERROR_CODE GetErrorCode();
	BOOL GetInstallError( LPTSTR szError, const int cch );
	BOOL GetUninstallError(LPTSTR szError, const int cch);
	BOOL GetAgreementShown();
	BOOL GetAgreementIsShow();
	BOOL GetAgreementURL( LPTSTR szAgreementURL, const int cch );
	LPCTSTR GetGuid();	

	//  ¸ 
	void		SetUpdateStatus(UPDATE_STATUS us)
	{
		m_cs.Enter();
		m_UpdateStatus = us;
		m_cs.Leave();
	}
	// Ʈ    (Agent dll)
	UPDATE_STATUS GetUpdateStatus()
	{
		UPDATE_STATUS us;
		m_cs.Enter();
		us = m_UpdateStatus;
		m_cs.Leave();
		return us;
	}	
protected:
	UPDATE_ERROR_CODE	m_nErrorCode;
	UPDATE_STATUS m_UpdateStatus;
	CCriticalSection m_cs;
};

LPCTSTR GetErrorString(UPDATE_ERROR_CODE nErrCode);

